package com.ibm.calendar;

/**
 * Plugin Interface was created to make a bridge
 * between the calendar and the different plugins.
 * @version 1.0
 * @author Mohammed Odeh
 */
public interface Plugin
{
/**
 * initPlugin method was created to initialize the plugin.
 */
public void initPlugin();
/**
 * setInfo method was created to pass the important data that is neaded 
 *    by the plugin from the calendar.
 * @param c represent the current date.
 * @param I represent the specified image for the plugin.
 * @param x represent the x coordinates for the plugin to be placed in.
 * @param y represent the y coordinates for the plugin to be placed in.
 */
public void setInfo(java.util.Calendar c, java.awt.Image I, int x, int y);
}